Cloo 0.9.1

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Properties
Cloo.ComputeCommandQueue Class Reference

Represents an OpenCL command queue. More...

Inheritance diagram for Cloo.ComputeCommandQueue:

List of all members.

## Public Member Functions
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, long sourceOffset, long destinationOffset, long region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, long sourceRowPitch, long destinationRowPitch, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBuffer< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, long sourceRowPitch, long destinationRowPitch, long sourceSlicePitch, long destinationSlicePitch, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source buffer to a destination buffer.
void | CopyBufferToImage< T > (ComputeBufferBase< T > source, ComputeImage destination, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a buffer to an image.
void | CopyBufferToImage< T > (ComputeBufferBase< T > source, ComputeImage2D destination, long sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a buffer to an image.
void | CopyBufferToImage< T > (ComputeBufferBase< T > source, ComputeImage3D destination, long sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a buffer to an image.
void | CopyImage (ComputeImage source, ComputeImage destination, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source image to a destination image.
void | CopyImage (ComputeImage2D source, ComputeImage2D destination, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source image to a destination image.
void | CopyImage (ComputeImage2D source, ComputeImage3D destination, SysIntX2 sourceOffset, SysIntX3 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source image to a destination image.
void | CopyImage (ComputeImage3D source, ComputeImage2D destination, SysIntX3 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source image to a destination image.
void | CopyImage (ComputeImage3D source, ComputeImage3D destination, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a source image to a destination image.
void | CopyImageToBuffer< T > (ComputeImage source, ComputeBufferBase< T > destination, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from an image to a buffer.
void | CopyImageToBuffer< T > (ComputeImage2D source, ComputeBufferBase< T > destination, SysIntX2 sourceOffset, long destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from an image to a buffer.
void | CopyImageToBuffer< T > (ComputeImage3D source, ComputeBufferBase< T > destination, SysIntX3 sourceOffset, long destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from a 3D image to a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[] destination, bool blocking, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[] destination, bool blocking, long sourceOffset, long destinationOffset, long region, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[,] destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[,,] destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[,] destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, long sourceRowPitch, long destinationRowPitch, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromBuffer< T > (ComputeBufferBase< T > source, ref T[,,] destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, long sourceRowPitch, long destinationRowPitch, long sourceSlicePitch, long destinationSlicePitch, IList< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | ReadFromImage (ComputeImage source, IntPtr destination, bool blocking, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from an image.
void | ReadFromImage (ComputeImage2D source, IntPtr destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from an image.
void | ReadFromImage (ComputeImage3D source, IntPtr destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from an image.
void | ReadFromImage (ComputeImage2D source, IntPtr destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 region, long sourceRowPitch, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from an image.
void | ReadFromImage (ComputeImage3D source, IntPtr destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 region, long sourceRowPitch, long sourceSlicePitch, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from an image.
void | WriteToBuffer< T > (T[] source, ComputeBufferBase< T > destination, bool blocking, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToBuffer< T > (T[] source, ComputeBufferBase< T > destination, bool blocking, long sourceOffset, long destinationOffset, long region, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToBuffer< T > (T[,] source, ComputeBufferBase< T > destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToBuffer< T > (T[,,] source, ComputeBufferBase< T > destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToBuffer< T > (T[,] source, ComputeBufferBase< T > destination, bool blocking, SysIntX2 sourceOffset, SysIntX2 destinationOffset, SysIntX2 region, long sourceRowPitch, long destinationRowPitch, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToBuffer< T > (T[,,] source, ComputeBufferBase< T > destination, bool blocking, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, long sourceRowPitch, long destinationRowPitch, long sourceSlicePitch, long destinationSlicePitch, IList< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | WriteToImage (IntPtr source, ComputeImage destination, bool blocking, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to an image.
void | WriteToImage (IntPtr source, ComputeImage2D destination, bool blocking, SysIntX2 destinationOffset, SysIntX2 region, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to an image.
void | WriteToImage (IntPtr source, ComputeImage3D destination, bool blocking, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to an image.
void | WriteToImage (IntPtr source, ComputeImage2D destination, bool blocking, SysIntX2 destinationOffset, SysIntX2 region, long destinationRowPitch, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to an image.
void | WriteToImage (IntPtr source, ComputeImage3D destination, bool blocking, SysIntX3 destinationOffset, SysIntX3 region, long destinationRowPitch, long destinationSlicePitch, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to an image.
| ComputeCommandQueue (ComputeContext context, ComputeDevice device, ComputeCommandQueueFlags properties)
| Creates a new ComputeCommandQueue.
void | AcquireGLObjects (ICollection< ComputeMemory > memObjs, ICollection< ComputeEventBase > events)
| Enqueues a command to acquire a collection of ComputeMemorys that have been previously created from OpenGL objects.
void | AddBarrier ()
| Enqueues a barrier.
ComputeEvent | AddMarker ()
| Enqueues a marker.
void | Copy< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, long sourceOffset, long destinationOffset, long region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data between buffers.
void | Copy< T > (ComputeBufferBase< T > source, ComputeBufferBase< T > destination, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, long sourceRowPitch, long sourceSlicePitch, long destinationRowPitch, long destinationSlicePitch, ICollection< ComputeEventBase > events)
| Enqueues a command to copy a 2D or 3D region of elements between two buffers.
void | Copy< T > (ComputeBufferBase< T > source, ComputeImage destination, long sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from buffer to ComputeImage.
void | Copy< T > (ComputeImage source, ComputeBufferBase< T > destination, SysIntX3 sourceOffset, long destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data from ComputeImage to buffer.
void | Copy (ComputeImage source, ComputeImage destination, SysIntX3 sourceOffset, SysIntX3 destinationOffset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to copy data between ComputeImages.
void | ExecuteTask (ComputeKernel kernel, ICollection< ComputeEventBase > events)
| Enqueues a command to execute a single ComputeKernel.
void | Execute (ComputeKernel kernel, long[] globalWorkOffset, long[] globalWorkSize, long[] localWorkSize, ICollection< ComputeEventBase > events)
| Enqueues a command to execute a range of ComputeKernels in parallel.
void | Finish ()
| Blocks until all previously enqueued commands are issued to the ComputeCommandQueue.Device and have completed.
void | Flush ()
| Issues all previously enqueued commands to the ComputeCommandQueue.Device.
IntPtr | Map< T > (ComputeBufferBase< T > buffer, bool blocking, ComputeMemoryMappingFlags flags, long offset, long region, ICollection< ComputeEventBase > events)
| Enqueues a command to map a part of a buffer into the host address space.
IntPtr | Map (ComputeImage image, bool blocking, ComputeMemoryMappingFlags flags, SysIntX3 offset, SysIntX3 region, ICollection< ComputeEventBase > events)
| Enqueues a command to map a part of a ComputeImage into the host address space.
void | Read< T > (ComputeBufferBase< T > source, bool blocking, long offset, long region, IntPtr destination, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from a buffer.
void | Read (ComputeImage source, bool blocking, SysIntX3 offset, SysIntX3 region, long rowPitch, long slicePitch, IntPtr destination, ICollection< ComputeEventBase > events)
| Enqueues a command to read data from a ComputeImage.
void | ReleaseGLObjects (ICollection< ComputeMemory > memObjs, ICollection< ComputeEventBase > events)
| Enqueues a command to release ComputeMemorys that have been created from OpenGL objects.
void | Unmap (ComputeMemory memory, ref IntPtr mappedPtr, ICollection< ComputeEventBase > events)
| Enqueues a command to unmap a buffer or a ComputeImage from the host address space.
void | Wait (ICollection< ComputeEventBase > events)
| Enqueues a wait command for a collection of ComputeEvents to complete before any future commands queued in the ComputeCommandQueue are executed.
void | Write< T > (ComputeBufferBase< T > destination, bool blocking, long destinationOffset, long region, IntPtr source, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to a buffer.
void | Write (ComputeImage destination, bool blocking, SysIntX3 destinationOffset, SysIntX3 region, long rowPitch, long slicePitch, IntPtr source, ICollection< ComputeEventBase > events)
| Enqueues a command to write data to a ComputeImage.
## Protected Member Functions
override void | Dispose (bool manual)
| Releases the associated OpenCL object.
## Properties
CLCommandQueueHandle | Handle`[get, set]`
| The handle of the ComputeCommandQueue.
ComputeContext | Context`[get]`
| Gets the ComputeContext of the ComputeCommandQueue.
ComputeDevice | Device`[get]`
| Gets the ComputeDevice of the ComputeCommandQueue.
bool | OutOfOrderExecution`[get]`
| Gets the out-of-order execution mode of the commands in the ComputeCommandQueue.
bool | Profiling`[get]`
| Gets the profiling mode of the commands in the ComputeCommandQueue.

## Detailed Description

Represents an OpenCL command queue.

A command queue is an object that holds commands that will be executed on a specific device. The command queue is created on a specific device in a context. Commands to a command queue are queued in-order but may be executed in-order or out-of-order.

See also:
  ComputeContext, ComputeDevice

## Constructor & Destructor Documentation

Cloo.ComputeCommandQueue.ComputeCommandQueue | ( | ComputeContext | context,
|  | ComputeDevice | device,
|  | ComputeCommandQueueFlags | properties
| ) |  |

Creates a new ComputeCommandQueue.

Parameters:

  context | A ComputeContext.
  device | A ComputeDevice associated with the context . It can either be one of ComputeContext.Devices or have the same ComputeDeviceTypes as the device specified when the context is created.
  properties | The properties for the ComputeCommandQueue.

## Member Function Documentation

void Cloo.ComputeCommandQueue.AcquireGLObjects | ( | ICollection< ComputeMemory > | memObjs,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to acquire a collection of ComputeMemorys that have been previously created from OpenGL objects.

Parameters:

  memObjs | A collection of OpenCL memory objects that correspond to OpenGL objects.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.AddBarrier | ( |  | ) |

Enqueues a barrier.

A barrier ensures that all queued commands have finished execution before the next batch of commands can begin execution.

ComputeEvent Cloo.ComputeCommandQueue.AddMarker | ( |  | ) |

Enqueues a marker.

void Cloo.ComputeCommandQueue.Copy | ( | ComputeImage | source,
|  | ComputeImage | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data between ComputeImages.

Parameters:

  source | The ComputeImage to copy from.
  destination | The ComputeImage to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.Copy< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | long | sourceOffset,
|  | long | destinationOffset,
|  | long | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data between buffers.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.Copy< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeImage | destination,
|  | long | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from buffer to ComputeImage.

Template Parameters:

  T | The type of data in source .

Parameters:

  source | The buffer to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.Copy< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | sourceRowPitch,
|  | long | sourceSlicePitch,
|  | long | destinationRowPitch,
|  | long | destinationSlicePitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy a 2D or 3D region of elements between two buffers.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  sourceRowPitch | The size of the source buffer row in bytes. If set to zero then sourceRowPitch equals `region.X * sizeof(T)`.
  sourceSlicePitch | The size of the source buffer 2D slice in bytes. If set to zero then sourceSlicePitch equals `region.Y * sizeof(T) * sourceRowPitch`.
  destinationRowPitch | The size of the destination buffer row in bytes. If set to zero then destinationRowPitch equals `region.X * sizeof(T)`.
  destinationSlicePitch | The size of the destination buffer 2D slice in bytes. If set to zero then destinationSlicePitch equals `region.Y * sizeof(T) * destinationRowPitch`.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

Requires OpenCL 1.1.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.Copy< T > | ( | ComputeImage | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX3 | sourceOffset,
|  | long | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from ComputeImage to buffer.

Parameters:

  source | The image to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | long | sourceOffset,
|  | long | destinationOffset,
|  | long | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | long | sourceSlicePitch,
|  | long | destinationSlicePitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source buffer to a destination buffer.

Template Parameters:

  T | The type of data in the buffers.

Parameters:

  source | The buffer to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  sourceSlicePitch | The size of a 2D slice of elements of source in bytes.
  destinationSlicePitch | The size of a 2D slice of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBufferToImage< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeImage2D | destination,
|  | long | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a buffer to an image.

Template Parameters:

  T | The type of data in source .

Parameters:

  source | The buffer to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBufferToImage< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeImage3D | destination,
|  | long | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a buffer to an image.

Template Parameters:

  T | The type of data in source .

Parameters:

  source | The buffer to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyBufferToImage< T > | ( | ComputeBufferBase< T > | source,
|  | ComputeImage | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a buffer to an image.

Template Parameters:

  T | The type of data in source .

Parameters:

  source | The buffer to copy from.
  destination | The image to copy to.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyImage | ( | ComputeImage | source,
|  | ComputeImage | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source image to a destination image.

Parameters:

  source | The image to copy from.
  destination | The image to copy to.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.CopyImage | ( | ComputeImage2D | source,
|  | ComputeImage2D | destination,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source image to a destination image.

Parameters:

  source | The image to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.CopyImage | ( | ComputeImage2D | source,
|  | ComputeImage3D | destination,
|  | SysIntX2 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source image to a destination image.

Parameters:

  source | The image to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.CopyImage | ( | ComputeImage3D | source,
|  | ComputeImage2D | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source image to a destination image.

Parameters:

  source | The image to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.CopyImage | ( | ComputeImage3D | source,
|  | ComputeImage3D | destination,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a source image to a destination image.

Parameters:

  source | The image to copy from.
  destination | The image to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.CopyImageToBuffer< T > | ( | ComputeImage2D | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX2 | sourceOffset,
|  | long | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from an image to a buffer.

Template Parameters:

  T | The type of data in destination .

Parameters:

  source | The image to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyImageToBuffer< T > | ( | ComputeImage3D | source,
|  | ComputeBufferBase< T > | destination,
|  | SysIntX3 | sourceOffset,
|  | long | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from a 3D image to a buffer.

Template Parameters:

  T | The type of data in destination .

Parameters:

  source | The image to copy from.
  destination | The buffer to copy to.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to copy.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.CopyImageToBuffer< T > | ( | ComputeImage | source,
|  | ComputeBufferBase< T > | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to copy data from an image to a buffer.

Template Parameters:

  T | The type of data in destination .

Parameters:

  source | The image to copy from.
  destination | The buffer to copy to.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

override void Cloo.ComputeCommandQueue.Dispose | ( | bool | manual | ) | `[protected, virtual]`

Releases the associated OpenCL object.

Parameters:

  manual | Specifies the operation mode of this method.

manual must be `true` if this method is invoked directly by the application.

Implements Cloo.ComputeResource.

void Cloo.ComputeCommandQueue.Execute | ( | ComputeKernel | kernel,
|  | long[] | globalWorkOffset,
|  | long[] | globalWorkSize,
|  | long[] | localWorkSize,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to execute a range of ComputeKernels in parallel.

Parameters:

  kernel | The ComputeKernel to execute.
  globalWorkOffset | An array of values that describe the offset used to calculate the global ID of a work-item instead of having the global IDs always start at offset (0, 0,... 0).
  globalWorkSize | An array of values that describe the number of global work-items in dimensions that will execute the kernel function. The total number of global work-items is computed as global_work_size[0] *...* global_work_size[work_dim - 1].
  localWorkSize | An array of values that describe the number of work-items that make up a work-group (also referred to as the size of the work-group) that will execute the kernel . The total number of work-items in a work-group is computed as local_work_size[0] *... * local_work_size[work_dim - 1].
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.ExecuteTask | ( | ComputeKernel | kernel,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to execute a single ComputeKernel.

Parameters:

  kernel | The ComputeKernel to execute.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.Finish | ( |  | ) |

Blocks until all previously enqueued commands are issued to the ComputeCommandQueue.Device and have completed.

void Cloo.ComputeCommandQueue.Flush | ( |  | ) |

Issues all previously enqueued commands to the ComputeCommandQueue.Device.

This method only guarantees that all previously enqueued commands get issued to the OpenCL device. There is no guarantee that they will be complete after this method returns.

IntPtr Cloo.ComputeCommandQueue.Map | ( | ComputeImage | image,
|  | bool | blocking,
|  | ComputeMemoryMappingFlags | flags,
|  | SysIntX3 | offset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to map a part of a ComputeImage into the host address space.

Parameters:

  image | The ComputeImage to map.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  flags | A list of properties for the mapping mode.
  offset | The image element position where mapping starts.
  region | The region of elements to map.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

IntPtr Cloo.ComputeCommandQueue.Map< T > | ( | ComputeBufferBase< T > | buffer,
|  | bool | blocking,
|  | ComputeMemoryMappingFlags | flags,
|  | long | offset,
|  | long | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to map a part of a buffer into the host address space.

Parameters:

  buffer | The buffer to map.
  blocking | The mode of operation of this call.
  flags | A list of properties for the mapping mode.
  offset | The buffer element position where mapping starts.
  region | The region of elements to map.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.Read | ( | ComputeImage | source,
|  | bool | blocking,
|  | SysIntX3 | offset,
|  | SysIntX3 | region,
|  | long | rowPitch,
|  | long | slicePitch,
|  | IntPtr | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a ComputeImage.

Parameters:

  source | The ComputeImage to read from.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  offset | The source element position where reading starts.
  region | The region of elements to read.
  rowPitch | The ComputeImage.RowPitch of source or 0.
  slicePitch | The ComputeImage.SlicePitch of source or 0.
  destination | A pointer to a preallocated memory area to read the data into.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

void Cloo.ComputeCommandQueue.Read< T > | ( | ComputeBufferBase< T > | source,
|  | bool | blocking,
|  | long | offset,
|  | long | region,
|  | IntPtr | destination,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Parameters:

  source | The buffer to read from.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  offset | The source element position where reading starts.
  region | The region of elements to read.
  destination | A pointer to a preallocated memory area to read the data into.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T[] | destination,
|  | bool | blocking,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T[] | destination,
|  | bool | blocking,
|  | long | sourceOffset,
|  | long | destinationOffset,
|  | long | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to read.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T | destination[,],
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to read.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T | destination[,,],
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to read.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T | destination[,],
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to read.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromBuffer< T > | ( | ComputeBufferBase< T > | source,
|  | ref T | destination[,,],
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | long | sourceSlicePitch,
|  | long | destinationSlicePitch,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The buffer to read from.
  destination | The array to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to read.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  sourceSlicePitch | The size of a 2D slice of elements of source in bytes.
  destinationSlicePitch | The size of a 2D slice of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.ReadFromImage | ( | ComputeImage | source,
|  | IntPtr | destination,
|  | bool | blocking,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from an image.

Parameters:

  source | The image to read from.
  destination | A valid pointer to a preallocated memory area to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.ReadFromImage | ( | ComputeImage3D | source,
|  | IntPtr | destination,
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from an image.

Parameters:

  source | The image to read from.
  destination | A valid pointer to a preallocated memory area to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  region | The region of elements to read.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.ReadFromImage | ( | ComputeImage2D | source,
|  | IntPtr | destination,
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from an image.

Parameters:

  source | The image to read from.
  destination | A valid pointer to a preallocated memory area to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  region | The region of elements to read.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.ReadFromImage | ( | ComputeImage3D | source,
|  | IntPtr | destination,
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | region,
|  | long | sourceRowPitch,
|  | long | sourceSlicePitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from an image.

Parameters:

  source | The image to read from.
  destination | A valid pointer to a preallocated memory area to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  region | The region of elements to read.
  sourceRowPitch | The size of a row of pixels of destination in bytes.
  sourceSlicePitch | The size of a 2D slice of pixels of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.ReadFromImage | ( | ComputeImage2D | source,
|  | IntPtr | destination,
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | region,
|  | long | sourceRowPitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to read data from an image.

Parameters:

  source | The image to read from.
  destination | A valid pointer to a preallocated memory area to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  region | The region of elements to read.
  sourceRowPitch | The size of a row of pixels of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.ReleaseGLObjects | ( | ICollection< ComputeMemory > | memObjs,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to release ComputeMemorys that have been created from OpenGL objects.

Parameters:

  memObjs | A collection of ComputeMemorys that correspond to OpenGL memory objects.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.Unmap | ( | ComputeMemory | memory,
|  | ref IntPtr | mappedPtr,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to unmap a buffer or a ComputeImage from the host address space.

Parameters:

  memory | The ComputeMemory.
  mappedPtr | The host address returned by a previous call to ComputeCommandQueue.Map. This pointer is `IntPtr.Zero` after this method returns.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

void Cloo.ComputeCommandQueue.Wait | ( | ICollection< ComputeEventBase > | events | ) |

Enqueues a wait command for a collection of ComputeEvents to complete before any future commands queued in the ComputeCommandQueue are executed.

Parameters:

  events | The ComputeEvents that this command will wait for.

void Cloo.ComputeCommandQueue.Write | ( | ComputeImage | destination,
|  | bool | blocking,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | rowPitch,
|  | long | slicePitch,
|  | IntPtr | source,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a ComputeImage.

Parameters:

  destination | The ComputeImage to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  rowPitch | The ComputeImage.RowPitch of destination or 0.
  slicePitch | The ComputeImage.SlicePitch of destination or 0.
  source | The content written to the ComputeImage.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

void Cloo.ComputeCommandQueue.Write< T > | ( | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | long | destinationOffset,
|  | long | region,
|  | IntPtr | source,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Parameters:

  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  source | The data written to the buffer.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` or read-only a new ComputeEvent identifying this command is created and attached to the end of the collection.

If blocking is `true` this method will not return until the command completes. If blocking is `false` this method will return immediately after the command is enqueued.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T | source[,],
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T[] | source,
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | long | sourceOffset,
|  | long | destinationOffset,
|  | long | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T | source[,],
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | SysIntX2 | sourceOffset,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T | source[,,],
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T[] | source,
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToBuffer< T > | ( | T | source[,,],
|  | ComputeBufferBase< T > | destination,
|  | bool | blocking,
|  | SysIntX3 | sourceOffset,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | sourceRowPitch,
|  | long | destinationRowPitch,
|  | long | sourceSlicePitch,
|  | long | destinationSlicePitch,
|  | IList< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to a buffer.

Template Parameters:

  T | The type of data in the buffer.

Parameters:

  source | The array to read from.
  destination | The buffer to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  sourceOffset | The source element position where reading starts.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  sourceRowPitch | The size of a row of elements of source in bytes.
  destinationRowPitch | The size of a row of elements of destination in bytes.
  sourceSlicePitch | The size of a 2D slice of elements of source in bytes.
  destinationSlicePitch | The size of a 2D slice of elements of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

Type Constraints

  T | : | struct |

void Cloo.ComputeCommandQueue.WriteToImage | ( | IntPtr | source,
|  | ComputeImage | destination,
|  | bool | blocking,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to an image.

Parameters:

  source | A pointer to a memory area to read from.
  destination | The image to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.WriteToImage | ( | IntPtr | source,
|  | ComputeImage3D | destination,
|  | bool | blocking,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to an image.

Parameters:

  source | A pointer to a memory area to read from.
  destination | The image to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.WriteToImage | ( | IntPtr | source,
|  | ComputeImage3D | destination,
|  | bool | blocking,
|  | SysIntX3 | destinationOffset,
|  | SysIntX3 | region,
|  | long | destinationRowPitch,
|  | long | destinationSlicePitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to an image.

Parameters:

  source | A pointer to a memory area to read from.
  destination | The image to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  destinationRowPitch | The size of a row of pixels of destination in bytes.
  destinationSlicePitch | The size of a 2D slice of pixels of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.WriteToImage | ( | IntPtr | source,
|  | ComputeImage2D | destination,
|  | bool | blocking,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | long | destinationRowPitch,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to an image.

Parameters:

  source | A pointer to a memory area to read from.
  destination | The image to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  destinationRowPitch | The size of a row of pixels of destination in bytes.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

void Cloo.ComputeCommandQueue.WriteToImage | ( | IntPtr | source,
|  | ComputeImage2D | destination,
|  | bool | blocking,
|  | SysIntX2 | destinationOffset,
|  | SysIntX2 | region,
|  | ICollection< ComputeEventBase > | events
| ) |  |

Enqueues a command to write data to an image.

Parameters:

  source | A pointer to a memory area to read from.
  destination | The image to write to.
  blocking | The mode of operation of this command. If `true` this call will not return until the command has finished execution.
  destinationOffset | The destination element position where writing starts.
  region | The region of elements to write.
  events | A collection of events that need to complete before this particular command can be executed. If events is not `null` a new event identifying this command is attached to the end of the collection.

## Property Documentation

ComputeContext Cloo.ComputeCommandQueue.Context`[get]`

Gets the ComputeContext of the ComputeCommandQueue.

The ComputeContext of the ComputeCommandQueue.

ComputeDevice Cloo.ComputeCommandQueue.Device`[get]`

Gets the ComputeDevice of the ComputeCommandQueue.

The ComputeDevice of the ComputeCommandQueue.

CLCommandQueueHandle Cloo.ComputeCommandQueue.Handle`[get, set]`

The handle of the ComputeCommandQueue.

bool Cloo.ComputeCommandQueue.OutOfOrderExecution`[get]`

Gets the out-of-order execution mode of the commands in the ComputeCommandQueue.

Is `true` if ComputeCommandQueue has out-of-order execution mode enabled and `false` otherwise.

bool Cloo.ComputeCommandQueue.Profiling`[get]`

Gets the profiling mode of the commands in the ComputeCommandQueue.

Is `true` if ComputeCommandQueue has profiling enabled and `false` otherwise.

The documentation for this class was generated from the following files:

- Cloo/Source/ComputeCommandQueue.Added.cs
- Cloo/Source/ComputeCommandQueue.cs